#include "Vram.h"
#include "Chars.h"

extern const byte[] MonoPattern;

static const byte[] PatternColorTable = {
	27, 3,
    52, 2,
    8, 3,
    0xff
};


void InitVram()
{
    {
        byte pattern;
        ptr<byte> pSource, pPattern;
        pattern = 0;
        pSource = PatternColorTable;
        pPattern = MonoPattern;
        while (pSource[0] != 0xff) {
            byte count, color;
            count = *pSource; ++pSource;
            color = *pSource; ++pSource;
            SetPatternMono(pPattern, pattern, color, count);
            pattern += count;
            pPattern += ((word)count) << 2;
        }
    }
}


void Put2S(ptr<byte> pVram, ptr<byte> pChars)
{
    repeat (2) {
        repeat (2) {
            *pVram = *pChars;
            ++pChars;
            ++pVram;
        }
        pVram += VramRowSize - 2;
    }
}


void Put2C(byte x, byte y, byte c)
{
    ptr<byte> pVram;
    pVram = VramPtr(x, y);
    repeat (2) {
        repeat (2) {
            *pVram = c;
            ++c;
            ++pVram;
        }
        pVram += VramRowSize - 2;
    }
}
